﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DataGridViewCheckBox
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            LoadCheckList();

        }

        private void LoadCheckList()
        {
            int i = 0;
            while (i < 10)
            {
                i++;

                bool chk1 = false, chk2 = false, chk3 = false, chk4 = false;

                dgvCheckList.Rows.Add("분야" + i.ToString(), "안전위험 체크항목" + i.ToString(), chk1, chk2, chk3, chk4, "");
            }
        }

        private void dgvCheckList_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0 && (e.ColumnIndex == 2 || e.ColumnIndex == 3 || e.ColumnIndex == 4 || e.ColumnIndex == 5))
                this.dgvCheckList.CommitEdit(DataGridViewDataErrorContexts.Commit);

            //선택1을 체크하면 선택2,3,4는 체크해제
            if ((bool)this.dgvCheckList.CurrentCell.Value == true && e.ColumnIndex == 2)
            {
                this.dgvCheckList.Rows[e.RowIndex].Cells[3].Value = false;
                this.dgvCheckList.Rows[e.RowIndex].Cells[4].Value = false;
                this.dgvCheckList.Rows[e.RowIndex].Cells[5].Value = false;
            }

            //선택2을 체크하면 선택1,3,4는 체크해제
            if ((bool)this.dgvCheckList.CurrentCell.Value == true && e.ColumnIndex == 3)
            {
                this.dgvCheckList.Rows[e.RowIndex].Cells[2].Value = false;
                this.dgvCheckList.Rows[e.RowIndex].Cells[4].Value = false;
                this.dgvCheckList.Rows[e.RowIndex].Cells[5].Value = false;
            }

            //선택3을 체크하면 선택1,2,4는 체크해제
            if ((bool)this.dgvCheckList.CurrentCell.Value == true && e.ColumnIndex == 4)
            {
                this.dgvCheckList.Rows[e.RowIndex].Cells[2].Value = false;
                this.dgvCheckList.Rows[e.RowIndex].Cells[3].Value = false;
                this.dgvCheckList.Rows[e.RowIndex].Cells[5].Value = false;
            }

            //선택4을 체크하면 선택1,2,3는 체크해제
            if ((bool)this.dgvCheckList.CurrentCell.Value == true && e.ColumnIndex == 5)
            {
                this.dgvCheckList.Rows[e.RowIndex].Cells[2].Value = false;
                this.dgvCheckList.Rows[e.RowIndex].Cells[3].Value = false;
                this.dgvCheckList.Rows[e.RowIndex].Cells[4].Value = false;
            }

        }

        private void cbAllYes_CheckedChanged(object sender, EventArgs e)
        {
            foreach (DataGridViewRow row in dgvCheckList.Rows)
            {
                DataGridViewCheckBoxCell chkYes = (DataGridViewCheckBoxCell)row.Cells[2];
                chkYes.Value = cbAllYes.Checked; // !(chk.Value == null ? false : (bool)chk.Value); //because chk.Value is initialy null

                DataGridViewCheckBoxCell chkNo = (DataGridViewCheckBoxCell)row.Cells[3];
                chkNo.Value = !cbAllYes.Checked;
            }

        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            //conn.Open();
            string field = "", text = "", chk = "", msg = "";

            foreach (DataGridViewRow row in dgvCheckList.Rows)
            {
                field = row.Cells["Field"].Value.ToString().Trim();
                text = row.Cells["Desc"].Value.ToString().Trim();
                if (row.Cells["Msg"].Value == null || row.Cells["Msg"].Value.ToString().Trim() == "")
                    msg = " ";
                else
                    msg = row.Cells["Msg"].Value.ToString().Trim();

                if (row.Cells["Yes"].Value.ToString() == "True")
                    chk = "O";
                else
                    chk = "X";

                string sQuery = "INSERT INTO .... ";
                //comm.CommandText = sQuery;
                //comm.Connection = conn;
                //comm.ExecuteNonQuery();
            }
            //conn.Close();
            //conn.Dispose();


        }
    }
}
